From 982c3cd5e132ca9b84dd6a41aaf4babb4c25da59 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Sun, 15 Mar 2020 21:06:53 +0800
Subject: [PATCH 078/124] ath11k: check ATH11K_FLAG_CORE_STOPPED in resume and
 suspend

In WoW operation, ath11k_mac_op_stop isn't called, so
ATH11K_FLAG_CORE_STOPPED isn't set, host uses this flag to skip
MHI poweroff and poweron for WoW suspend/resume.

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: I3fd9b60c9a80919873cb0f27c5ab7d4cc64f7a36
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c | 6 ++++++
 drivers/net/wireless/ath/ath11k/mac.c  | 2 +-
 2 files changed, 7 insertions(+), 1 deletion(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index b0c5b39..47dc469 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -912,6 +912,9 @@ EXPORT_SYMBOL(ath11k_core_alloc);
 
 int ath11k_core_suspend(struct ath11k_base *ab)
 {
+	if (!test_bit(ATH11K_FLAG_CORE_STOPPED, &ab->dev_flags))
+		return 0;
+
 	ath11k_hif_irq_disable(ab);
 	ath11k_core_cutoff_stop(ab);
 	ath11k_hif_power_down(ab);
@@ -925,6 +928,9 @@ int ath11k_core_resume(struct ath11k_base *ab)
 {
 	int ret = 0;
 
+	if (!test_bit(ATH11K_FLAG_CORE_STOPPED, &ab->dev_flags))
+		return 0;
+
 	set_bit(ATH11K_FLAG_CORE_STARTING, &ab->dev_flags);
 	init_completion(&ab->fw_mac_restart);
 	ath11k_hif_power_up(ab);
diff --git a/drivers/net/wireless/ath/ath11k/mac.c b/drivers/net/wireless/ath/ath11k/mac.c
index f0ba85c..aefb633 100644
--- a/drivers/net/wireless/ath/ath11k/mac.c
+++ b/drivers/net/wireless/ath/ath11k/mac.c
@@ -4048,8 +4048,8 @@ static int ath11k_mac_op_start(struct ieee80211_hw *hw)
 				ret = -ETIMEDOUT;
 			}
 			clear_bit(ATH11K_FLAG_CORE_STARTING, &ab->dev_flags);
-			clear_bit(ATH11K_FLAG_CORE_STOPPED, &ab->dev_flags);
 		}
+		clear_bit(ATH11K_FLAG_CORE_STOPPED, &ab->dev_flags);
 		ar->state = ATH11K_STATE_ON;
 		break;
 	case ATH11K_STATE_RESTARTING:
-- 
2.7.4

